import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import javax.swing.border.*;

public class MassBalanceCalculator extends JFrame implements ChangeListener,ListSelectionListener, TableColumnModelListener,ActionListener
{
 JTable JT1,JTA,JTB,JTC,JTD,JTX,JTY,JT2;
 DefaultTableModel DTM1,DTMA,DTMB,DTMC,DTMD,DTMX,DTMY,DTM2,DTMX2,DTMSelect,DTMR,DTMSUM;
 JButton JB1,JB2;
  JButton JB3,JB4,JB5,JB6;
 TextArea TextArea1;
 JLabel JLSP; JButton JBSP1,JBSP2;
 int MM,CompNumber;
 JLabel JL1,JL2,JL3,JL4,JL5,JL6,JLT,JLT2,JLT3,JLP1,JLP2,JLP3,JL7,JL8;
JCheckBox JCB1,JCB2,JCB3,JCB4,JCB5;
LineBorder LB1;
JRadioButton JRB1,JRB2,JRB3,JRB4;
ButtonGroup BGroup1,BGroup2;

String[][] data1=
	{
		{"37.0", "0.0","0.0", "29.44", "0.34","38.85", "0.37", "0.0","0.0","0.0","0.0","0.0","0.0","0.0"},
		{"53.51","0.0","28.38","0.77", "0.0", "0.0", "12.12", "4.06","0.16","0.0","0.0","0.0","0.0","0.0"},
		{"52.54","1.31", "2.31","9.07", "0.0", "15.44", "19.33", "0.0","0.0","0.0","0.0","0.0","0.0","0.0"},
		{"0.13", "19.01", "1.21", "78.04", "0.61", "0.9","0.11","0.0", "0.0","0.0","0.0","0.0","0.0","0.0"},
		{"0.0", "0.0","0.0", "0.0","0.0","0.0","0.0", "0.0","0.0","0.0", "0.0","0.0","0.0","0.0"}
	};	
String[] dataA={"48.61", "2.78" ,"14.59", "13.06", "0.2","6.3","10.88","2.83","0.46","0.31","0.0","0.0","0.0","0.0"};
String[] dataB={"49.01","4.03","13.52","15.04","0.25","4.57","9.17","3.12","0.75","0.56","0.0","0.0","0.0","0.0"};
String[] NameX={"BasaltA","Ol","Pl","Aug","Mt","-","BasaltB"};
String[] NameY={"SiO2","TiO2","Al2O3","FeO*","MnO","MgO","CaO","NaO","K2O","P2O5","-","-","-","-"};	



     public MassBalanceCalculator () 
     {
     super("MassBalanceCalculator");
     this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
     getContentPane().setLayout(null);
	 
	TextArea1=new TextArea(20,30);
	 
	DTM1 = new DefaultTableModel(14,5);
	DTM2 = new DefaultTableModel(14,5);
	DTMA = new DefaultTableModel(14,1);
	DTMB = new DefaultTableModel(14,1);
	DTMC = new DefaultTableModel(1,7);
	DTMD = new DefaultTableModel(1,7);
	DTMX = new DefaultTableModel(1,7);
	DTMY = new DefaultTableModel(14,1);
	DTMX2 = new DefaultTableModel(1,7);
	DTMSelect = new DefaultTableModel(1,5);
	DTMR = new DefaultTableModel(14,1);
	DTMSUM = new DefaultTableModel(1,7);

	JT1 = new JTable(DTM1);
	JT2 = new JTable(DTM2);
	JTA = new JTable(DTMA);
	JTB = new JTable(DTMB);
	JTC = new JTable(DTMC);
	JTD = new JTable(DTMD);
	JTX = new JTable(DTMX);
	JTY = new JTable(DTMY);


	JT1.setRowHeight(18);
	JT2.setRowHeight(18);
	JTA.setRowHeight(18);
	JTB.setRowHeight(18);
	JTC.setRowHeight(18);
	JTD.setRowHeight(18);
	JTX.setRowHeight(18);
	JTY.setRowHeight(18);
	
	JT1.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
	JT1.setRowSelectionAllowed(false);
	JT1.setColumnSelectionAllowed(false);
	JT1.setCellSelectionEnabled(true);

	JTC.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
	JTC.setRowSelectionAllowed(false);
	JTC.setColumnSelectionAllowed(false);
	JTC.setCellSelectionEnabled(true);

	JTD.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
	JTD.setRowSelectionAllowed(false);
	JTD.setColumnSelectionAllowed(false);
	JTD.setCellSelectionEnabled(true);

	JTX.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
	JTX.setRowSelectionAllowed(false);
	JTX.setColumnSelectionAllowed(false);
	JTX.setCellSelectionEnabled(true);

	JT1.setAutoResizeMode(JT1.AUTO_RESIZE_OFF);
	JTC.setAutoResizeMode(JT1.AUTO_RESIZE_OFF);
	JTA.setBounds(110,65,60,252);
	JT1.setBounds(170,65,300,252);
	JTB.setBounds(470,65,60,252);
	JTC.setBounds(110,339,420,18);
	JTD.setBounds(110,364,420,18);
	JTX.setBounds(110,40,420,18);
	JTY.setBounds(50,65,60,252);

	getContentPane().add(JT1);
	JT1.getSelectionModel().addListSelectionListener(this);	 
	JT1.getColumnModel().addColumnModelListener(this);
	getContentPane().add(JTA);
	JTA.getSelectionModel().addListSelectionListener(this);	 
	JTA.getColumnModel().addColumnModelListener(this);		 
	getContentPane().add(JTB);
	JTB.getSelectionModel().addListSelectionListener(this);	 
	JTB.getColumnModel().addColumnModelListener(this);
	getContentPane().add(JTC);
	JTC.getSelectionModel().addListSelectionListener(this);	 
	JTC.getColumnModel().addColumnModelListener(this);
	getContentPane().add(JTD);
	getContentPane().add(JTX);
	getContentPane().add(JTY);
	 
	 JL1 = new JLabel();
	 JL1.setBounds(50,338,50,18);
	 getContentPane().add(JL1);
	 JL1.setText("SUM");
	 
	 JL2 = new JLabel();
	 JL2.setBounds(25,364,75,18);
	 getContentPane().add(JL2);
	 JL2.setText("proportion");
	 
	 JL3 = new JLabel();
	 JL3.setBounds(50,389,50,18);
	 getContentPane().add(JL3);
	 JL3.setText("SSR");
	 
	 JL4 = new JLabel();
	 JL4.setBounds(465,389,70,18);
	 getContentPane().add(JL4);
	 JL4.setText(" ");
	 
	  JL5 = new JLabel();
	 JL5.setBounds(50,414,50,18);
	 getContentPane().add(JL5);
	 JL5.setText("RMSR");
	 
	 JL6 = new JLabel();
	 JL6.setBounds(465,414,70,18);
	 getContentPane().add(JL6);
	 JL6.setText("");
	 
	 JL7 = new JLabel();
	 JL7.setBounds(110,389,300,18);
	 getContentPane().add(JL7);
	 JL7.setText("(sum of squares of residuals)");
	 
	 JL8 = new JLabel();
	 JL8.setBounds(110,414,300,18);
	 getContentPane().add(JL8);
	 JL8.setText("(root mean squares of residuals)");
	 
	 JLT = new JLabel();
	 JLT.setBounds(595,40,50,18);
	 getContentPane().add(JLT);
	 JLT.setText("");
	 
	 JLT2 = new JLabel();
	 JLT2.setBounds(545,10,120,36);
	 getContentPane().add(JLT2);
	 JLT2.setText("selected min. #");
	 
	 JCB1 = new JCheckBox();
	 JCB1.setBounds(175,15,20,20);
	 getContentPane().add(JCB1);
	 JCB1.setSelected(true);
	 JCB1.addChangeListener(this);
	 
	 JCB2 = new JCheckBox();
	 JCB2.setBounds(235,15,20,20);
	 getContentPane().add(JCB2);
	 JCB2.setSelected(true);
	 JCB2.addChangeListener(this);
	 
	 JCB3 = new JCheckBox();
	 JCB3.setBounds(295,15,20,20);
	 getContentPane().add(JCB3);
	 JCB3.setSelected(true);
	 JCB3.addChangeListener(this);

	 JCB4 = new JCheckBox();
	 JCB4.setBounds(355,15,20,20);
	 getContentPane().add(JCB4);
	 JCB4.setSelected(true);
	 JCB4.addChangeListener(this);

	 JCB5 = new JCheckBox();
	 JCB5.setBounds(415,15,20,20);
	 getContentPane().add(JCB5);
	 JCB5.setSelected(false);
	 JCB5.addChangeListener(this);

	JB1=new JButton("calc");
	JB1.setBounds(545,60,100,30);
	getContentPane().add(JB1);
	JB1.addActionListener(this);
	 
	 JB2=new JButton("save");
     JB2.setBounds(545,100,100,30);
     getContentPane().add(JB2);
	 JB2.addActionListener(this);
	 
	 JB3=new JButton("load");
     JB3.setBounds(545,140,100,30);
     getContentPane().add(JB3);
	 JB3.addActionListener(this);
	 
	 JB4=new JButton("clear");
     JB4.setBounds(545,180,100,30);
     getContentPane().add(JB4);
	 JB4.addActionListener(this);
	 
	 JB5=new JButton("example");
     JB5.setBounds(545,220,100,30);
     getContentPane().add(JB5);
	 JB5.addActionListener(this);
	 
	 JB6=new JButton("quit");
     JB6.setBounds(545,260,100,30);
     getContentPane().add(JB6);
	 JB6.addActionListener(this);
	 
	  LB1 = new LineBorder(Color.gray,3,false);
	  JLT3 = new JLabel();
	 JLT3.setBounds(20,438,630,3);
	 getContentPane().add(JLT3);
	 JLT3.setBorder(LB1);
	 
	 JLP1 = new JLabel();
	 JLP1.setBounds(25,466,115,18);
	 getContentPane().add(JLP1);
	 JLP1.setText("chem. comp. #");
 
	 int CompNumber=10;
	 JLSP = new JLabel();
	 JLSP.setBounds(130,466,25,20);
     getContentPane().add(JLSP);
	 JLSP.setText(Integer.toString((int)CompNumber));
	 
	 JBSP1=new JButton("up");
     JBSP1.setBounds(160,454,70,18);
     getContentPane().add(JBSP1);
	 JBSP1.addActionListener(this);
	 
	 JBSP2=new JButton("down");
     JBSP2.setBounds(160,479,70,18);
     getContentPane().add(JBSP2);
	 JBSP2.addActionListener(this);

	 
	 JLP2 = new JLabel();
	 JLP2.setBounds(280,454,220,18);
	 getContentPane().add(JLP2);
	 JLP2.setText("use normalized data to calculate");
	 
	 JRB1 = new JRadioButton("Yes",true);
	 JRB1.setBounds(530,454,50,20);
	 getContentPane().add(JRB1);

	 JRB2 = new JRadioButton("No",false);
	 JRB2.setBounds(600,454,50,20);
	 getContentPane().add(JRB2);
	 
	 BGroup1 = new ButtonGroup();
	 BGroup1.add(JRB1);
	 BGroup1.add(JRB2);
	 
	 JLP2 = new JLabel();
	 JLP2.setBounds(280,479,220,18);
	 getContentPane().add(JLP2);
	 JLP2.setText("include name data in load file ");
	 
	 JRB3 = new JRadioButton("Yes",false);
	 JRB3.setBounds(530,479,50,20);
	 getContentPane().add(JRB3);

	 JRB4 = new JRadioButton("No",true);
	 JRB4.setBounds(600,479,50,20);
	 getContentPane().add(JRB4);
	 
	 BGroup2 = new ButtonGroup();
	 BGroup2.add(JRB3);
	 BGroup2.add(JRB4);
	 
	for(int i=0;i<NameX.length;i++)
		{
			DTMX.setValueAt(NameX[i],0,i);
			DTMX2.setValueAt(NameX[i],0,i);
		}

	for(int i=0;i<NameY.length;i++)
			JTY.setValueAt(NameY[i],i,0);


	for(int j=0;j<5;j++)
		for(int i=0;i<14;i++)
		{
				DTM1.setValueAt(data1[j][i],i,j);
				DTM2.setValueAt(data1[j][i],i,j);
		}

	for(int i=0;i<14;i++)
	{
		DTMA.setValueAt(dataA[i],i,0);
		DTMB.setValueAt(dataB[i],i,0);
	}
	
	for(int i=0;i<4;i++)
	DTMSelect.setValueAt(Integer.toString(1),0,i);
	 DTMSelect.setValueAt(Integer.toString(0),0,4);
	 
	JT1.setColumnSelectionInterval(0,0);
	JTA.setColumnSelectionInterval(0,0);
	JTB.setColumnSelectionInterval(0,0);
	 
	 ChangeValueOfCell();
	 
	 }

	public void columnSelectionChanged(ListSelectionEvent ev)
	{
		ChangeValueOfCell();
	}
		
	public void  valueChanged (ListSelectionEvent e)
	{	
		ChangeValueOfCell();
	}
	
	public void columnAdded (TableColumnModelEvent ev){	}
	public void columnRemoved (TableColumnModelEvent ev){	}
	public void columnMoved (TableColumnModelEvent ev){	}
	public void columnMarginChanged (ChangeEvent ev){	}
	
	void ChangeValueOfCell()
	{
		double [] p=new double[7];
	
		ActionstateChanged();
		
		p[0]=0;
		p[6]=0;
		for(int j=0;j<14;j++)
			{
			try
				{
				p[0]+=Double.parseDouble((String)DTMA.getValueAt(j,0));
				p[6]+=Double.parseDouble((String)DTMB.getValueAt(j,0));
				}
			catch(Exception ex){};			
			}
			DTMSUM.setValueAt(Double.toString(p[0]),0,0);
			DTMSUM.setValueAt(Double.toString(p[6]),0,6);
			p[0]=RND(p[0],2);
			p[6]=RND(p[6],2);
			DTMC.setValueAt(Double.toString(p[0]),0,0);
			DTMC.setValueAt(Double.toString(p[6]),0,6);	
			
			for(int i=0;i<5;i++)
			{
					p[i+1]=0;
						for(int j=0;j<14;j++)
						{
						try
								{
								p[i+1]+=Double.parseDouble((String)DTM1.getValueAt(j,i));
								}
								catch(Exception ex){};
						}
					DTMSUM.setValueAt(Double.toString(p[i+1]),0,i+1);
					p[i+1]=RND(p[i+1],2);
					DTMC.setValueAt(Double.toString(p[i+1]),0,i+1);	
			}

			JTA.clearSelection();
			JTB.clearSelection();
			JT1.clearSelection();
			JTC.clearSelection();
			JTD.clearSelection();
			JTX.clearSelection();
			JTY.clearSelection();
	}
	
	public void stateChanged(ChangeEvent ev)
	{
		ActionstateChanged();
	}
	
	public void ActionstateChanged()
	{
	for(int j=0;j<5;j++)
		for(int i=0;i<14;i++)
			DTM2.setValueAt(Integer.toString(0),i,j);
	
		for(int i=1;i<7;i++)
			DTMX2.setValueAt(Integer.toString(0),0,i);		
			
		int nJC=0;
		if(JCB1.isSelected()) 
			{
				{for(int i=0;i<14;i++)
					DTM2.setValueAt(DTM1.getValueAt(i,0),i,nJC);
				}
			DTMX2.setValueAt(DTMX.getValueAt(0,1),0,nJC);
			DTMSelect.setValueAt(Integer.toString(1),0,0);
			nJC=nJC+1;
			}
		else	DTMSelect.setValueAt(Integer.toString(0),0,0);	
		if(JCB2.isSelected()) 
			{
				{for(int i=0;i<14;i++)
					DTM2.setValueAt(DTM1.getValueAt(i,1),i,nJC);
				}
			DTMX2.setValueAt(DTMX.getValueAt(0,2),0,nJC);	
			DTMSelect.setValueAt(Integer.toString(1),0,1);
			nJC=nJC+1;
			}
		else	DTMSelect.setValueAt(Integer.toString(0),0,1);	
		if(JCB3.isSelected()) 
			{
				{for(int i=0;i<14;i++)
					DTM2.setValueAt(DTM1.getValueAt(i,2),i,nJC);
			}
			DTMX2.setValueAt(DTMX.getValueAt(0,3),0,nJC);	
			DTMSelect.setValueAt(Integer.toString(1),0,2);
			nJC=nJC+1;
			}
		else	DTMSelect.setValueAt(Integer.toString(0),0,2);	
		if(JCB4.isSelected())
			{
				{for(int i=0;i<14;i++)
					DTM2.setValueAt(DTM1.getValueAt(i,3),i,nJC);
			}
			DTMX2.setValueAt(DTMX.getValueAt(0,4),0,nJC);	
			DTMSelect.setValueAt(Integer.toString(1),0,3);
			nJC=nJC+1;
			}
		else	DTMSelect.setValueAt(Integer.toString(0),0,3);	
		if(JCB5.isSelected()) 
				{
				{for(int i=0;i<14;i++)
					DTM2.setValueAt(DTM1.getValueAt(i,4),i,nJC);
				}
			DTMX2.setValueAt(DTMX.getValueAt(0,5),0,nJC);	
			DTMSelect.setValueAt(Integer.toString(1),0,4);
			nJC=nJC+1;
			}
		else	DTMSelect.setValueAt(Integer.toString(0),0,4);	
		DTMX2.setValueAt(DTMX.getValueAt(0,6),0,nJC);	
		JLT.setText(Integer.toString(nJC));
	}

	public void actionPerformed(ActionEvent ev)
	{
		if(ev.getSource().equals(JB1)) this.Caluclate();
		else if(ev.getSource().equals(JB2)) this.Savedata();
		else if(ev.getSource().equals(JB3)) this.Loaddata();
		else if(ev.getSource().equals(JB4)) this.Cleardata();
		else if(ev.getSource().equals(JB5)) this.Exampledata();
		else if(ev.getSource().equals(JB6)) this.QuitAppli();
		else if(ev.getSource().equals(JBSP1)) this.MChanged1();
		else if(ev.getSource().equals(JBSP2)) this.MChanged2();
	}
	
	public void MChanged1 ()
	{
	int i =Integer.parseInt(JLSP.getText());
	i=i+1;
	if(i>14) i=14;
	JLSP.setText(Integer.toString(i));
	}
	
	public void MChanged2 ()
	{
	int i =Integer.parseInt(JLSP.getText());
	i=i-1;
	if(i<1) i=1;
	JLSP.setText(Integer.toString(i));
	}
	public void QuitAppli()
	{	
	System.exit(0);
	}
	
	public void Loaddata()
	{	
		String All_Data="";
		try{
			FileDialog FD1 =new FileDialog(this,"Select TextFile.",FileDialog.LOAD);
			FD1.setVisible(true);
			 if(FD1.getFile()==null) return;
			String Filename1=FD1.getDirectory()+FD1.getFile();			
			FileReader FR1= new FileReader(Filename1);
	 		BufferedReader BR1= new BufferedReader(FR1);
			 String Read_Data;			 
						int m=0;			
				 	while ((Read_Data=BR1.readLine())!=null)
				 	{m=m+1;
			 		All_Data=All_Data+Read_Data+'\n';
			 		}
			 MM=m;
			 FR1.close();
			 TextArea1.replaceRange("",TextArea1.getSelectionStart(),TextArea1.getSelectionEnd());
			 TextArea1.setText(All_Data);
			 
			 ButtonModel BM2 = BGroup2.getSelection();
			if(BM2 == JRB3.getModel())
				InputData2(); 
			else InputData();
		
				}catch(Exception e)
						{System.out.println(e);}						
	}
	
	public void InputData()
	{	
	int n=0,m,a=0;
	StringTokenizer ST1=new StringTokenizer(TextArea1.getText());
	double[] x = new double[1000];
	double[][] xx = new double[15][30];
	while(ST1.hasMoreTokens())
				{
			 		try{
						x[n++]=Double.valueOf(ST1.nextToken()).doubleValue();
						}
						catch(NumberFormatException ex){};					
				}

		m=n/MM;
		for(int i=0;i<MM;i++)
		{
			for(int j=0;j<m;j++)
			{
				xx[i][j]=x[a+j];
			}		
			a=a+m;
		}
		
		Cleardata();
		for(int i=0;i<14;i++)
		{
			DTMA.setValueAt(Double.toString(xx[i][0]),i,0);
			DTMB.setValueAt(Double.toString(xx[i][m-1]),i,0);
		}
		
		if(m>7) m=7;
		for(int j=1;j<m-1;j++)
		{
			for(int i=0;i<14;i++)
			{
				DTM1.setValueAt(Double.toString(xx[i][j]),i,j-1);
				DTM2.setValueAt(Double.toString(xx[i][j]),i,j-1);
			}
		}
	}
	
	public void InputData2()
	{	
	int n=0,m,a=0;
	StringTokenizer ST1=new StringTokenizer(TextArea1.getText());
	double[][] xx = new double[15][30];
	String[] xS = new String[1000];
	String[] xxSX = new String[10];
	String[] xxSY = new String[15];
	while(ST1.hasMoreTokens())
				{
			 		try{
						xS[n++]=ST1.nextToken();
						}
						catch(NumberFormatException ex){};					
				}

		m=(n+1)/MM;
		for(int j=0;j<m-2;j++)
		{
			xxSX[j]=xS[j];
		}
		
		for(int j=m-2;j<6;j++)
		{
			xxSX[j]=" - ";
		}
		xxSX[6]=xS[m-2];

		for(int i=0;i<MM-1;i++)
		{
			xxSY[i]=xS[(i+1)*m-1];
		}
		
		a=m;
		for(int i=0;i<MM-1;i++)
		{
			for(int j=0;j<m-1;j++)
			{
				xx[i][j]=Double.parseDouble((String)xS[a+j]);
				
			}	
			a=a+m;
		}
	
		
	Cleardata();
	for(int j=0;j<7;j++)
		{
			DTMX.setValueAt(xxSX[j],0,j);
			DTMX2.setValueAt(xxSX[j],0,j);
		}
		
		if(MM>14) 
		{
			for(int i=0;i<14;i++)
				JTY.setValueAt(xxSY[i],i,0);
		}
		else
		{
			for(int i=0;i<MM-1;i++)
			JTY.setValueAt(xxSY[i],i,0);
			for(int i=MM-1;i<14;i++)
			JTY.setValueAt("-",i,0);		
		}
		
		if(MM>14)
		{
			for(int i=0;i<14;i++)
			{
				DTMA.setValueAt(Double.toString(xx[i][0]),i,0);
				DTMB.setValueAt(Double.toString(xx[i][m-2]),i,0);
			}
		}
		else
		{
			for(int i=0;i<MM-1;i++)
			{
				DTMA.setValueAt(Double.toString(xx[i][0]),i,0);
				DTMB.setValueAt(Double.toString(xx[i][m-2]),i,0);
			}
			for(int i=MM-1;i<14;i++)
			{
				DTMA.setValueAt(Double.toString(0),i,0);
				DTMB.setValueAt(Double.toString(0),i,0);
			}		
		}
		
		if(m>8) m=8;
		for(int j=1;j<m-2;j++)
		{
			for(int i=0;i<14;i++)
			{
				DTM1.setValueAt(Double.toString(xx[i][j]),i,j-1);
				DTM2.setValueAt(Double.toString(xx[i][j]),i,j-1);
			}
		}	
			
	
	ChangeValueOfCell();		
	}
	
	public void Cleardata()
	{
		for(int j=0;j<5;j++)
		for(int i=0;i<14;i++)
			DTM1.setValueAt(Double.toString(0),i,j);
		
			for(int i=0;i<14;i++)
			{
				DTMA.setValueAt(Double.toString(0),i,0);
				DTMB.setValueAt(Double.toString(0),i,0);
				DTMR.setValueAt(Double.toString(0),i,0);
			}
		for(int j=0;j<7;j++)
		{
			DTMC.setValueAt("",0,j);
			DTMD.setValueAt("",0,j);
		}
		JL4.setText("");
		JL6.setText("");
		ChangeValueOfCell();			
	}
	
	public void Exampledata()
	{
		for(int j=0;j<5;j++)
		for(int i=0;i<14;i++)
		{
			DTM1.setValueAt(data1[j][i],i,j);
			DTM2.setValueAt(data1[j][i],i,j);
		}
			
		for(int i=0;i<14;i++)
		{
			DTMA.setValueAt(dataA[i],i,0);
			DTMB.setValueAt(dataB[i],i,0);
		}
			ChangeValueOfCell();		
	}
	
	
	public void Savedata()
	{

                try {
                        FileDialog FD2= new FileDialog(this,"Select Text File.",FileDialog.SAVE);						
                        FD2.setVisible(true);
						if(FD2.getFile()==null) return;
                        String fname = FD2.getDirectory() + FD2.getFile();
                        FileWriter FW2 = new FileWriter(fname);
						
						FW2.write((String)("result"+"	"+DTMX.getValueAt(0,0)+"	"));
						
						for(int i=0;i<Integer.parseInt(JLT.getText())+1;i++)
						FW2.write((String)(DTMX2.getValueAt(0,i)+"	"));
						
						FW2.write((String)("residuals"));
						FW2.write("\n");
						
						for(int j=0;j<14;j++)
						{
							FW2.write((String)(JTY.getValueAt(j,0)+"	"+DTMA.getValueAt(j,0)+"	"));
								for(int i=0;i<Integer.parseInt(JLT.getText());i++)
									{
                        				FW2.write((String)(DTM2.getValueAt(j,i)+"	"));
									}
							FW2.write((String)(DTMB.getValueAt(j,0)+"	"+DTMR.getValueAt(j,0)));
							FW2.write("\n");
						}
						
						FW2.write((String)("proportion"+"	"+DTMD.getValueAt(0,0)+"	"));
						for(int j=0;j<5;j++)
						{
							if((DTMSelect.getValueAt(0,j)).equals(Integer.toString(1)))
								FW2.write((String)(DTMD.getValueAt(0,(j+1))+"	"));
							else {}	
						}
						FW2.write((String)(DTMD.getValueAt(0,6)+"	"));
						FW2.write("\n\n");	
						FW2.write((String)("SSR="+"	"+JL4.getText())+"		"+"data:"+"	");
						if(BGroup1.getSelection() == JRB1.getModel())
						FW2.write("normalized ");
						
						else FW2.write("not normalized");
						FW2.write("\n");	
						FW2.write((String)("RMSR="+"	"+JL6.getText()+"		"+"comp.#"+"	"));
						
						FW2.write(JLSP.getText());	
                        FW2.close();
                } catch(Exception e) {
                        System.out.println(e);
                }
        
	}
	
	public void Caluclate()
	{
		double[] BulkA=new double[14];
		double[] BulkB=new double[14];
		double[][] Mineral=new double[14][6];
		double[][] MatrixP=new double[14][6];
		double[] MatrixQ=new double[14];
		double[][] q=new double[14][6];
		double[][] a=new double[14][6];
		double[][] r=new double[6][6];
		double[] z=new double[14];
		double[] E=new double[14];
		double[] d=new double[6];
		double[] x=new double[6];
		int m=Integer.parseInt(JLT.getText());	
		ButtonModel BM1 = BGroup1.getSelection();
		double [] p=new double[7];
		
		for(int i=0;i<7;i++)
			p[i]=Double.parseDouble((String)DTMSUM.getValueAt(0,i));	
		
		if(BM1== JRB1.getModel())
		{
					for(int j=0;j<14;j++)
				{
				try
					{
						BulkA[j]=Double.parseDouble((String)DTMA.getValueAt(j,0))*100/p[0];
						BulkB[j]=Double.parseDouble((String)DTMB.getValueAt(j,0))*100/p[6];			
					}
				catch(Exception ex){}		
				}				
		}		
		else
		{
			for(int j=0;j<14;j++)
				{
				try
					{
						BulkA[j]=Double.parseDouble((String)DTMA.getValueAt(j,0));
						BulkB[j]=Double.parseDouble((String)DTMB.getValueAt(j,0));
					}
				catch(Exception ex){}		
				}
		}	
		
		if(BM1== JRB1.getModel())
		{
			for(int i=0;i<m;i++)
				{
					for(int j=0;j<14;j++)
						{
						try
							{
								Mineral[j][i]=Double.parseDouble((String)DTM2.getValueAt(j,i))*100/p[i+1];
							}
				catch(Exception ex2){}		
						}
				}		
		}
		else
		{
			for(int i=0;i<m;i++)
				{
					for(int j=0;j<14;j++)
						{
						try
							{
								Mineral[j][i]=Double.parseDouble((String)DTM2.getValueAt(j,i));
							}
				catch(Exception ex2){}		
						}
				}
		}

		for(int i=0;i<m;i++)
		{
			for(int j=0;j<14;j++)
			{  
			MatrixP[j][i]=(double)(Mineral[j][i]-BulkB[j]);
			a[j][i]=MatrixP[j][i];
			}
		}	

		for(int j=0;j<14;j++)
			{
				MatrixQ[j]=(double)(BulkA[j]-BulkB[j]);
			}

			for(int j=0;j<14;j++)
			{
				MatrixP[j][m]=MatrixQ[j];
			}
			
    
		for(int k=0;k<m;k++)
		{

				for(int j=0;j<14;j++)
				{
					q[j][k]=MatrixP[j][k];
				}

				d[k]=0;
				for(int j=0;j<14;j++)
				{
					d[k]=d[k]+q[j][k]*q[j][k];
				 }

				r[k][k]=1;
				
				for(int i=k+1;i<m+1;i++)
				{
					double S=0;
					for(int j=0;j<14;j++)
					{
						S=S+q[j][k]*MatrixP[j][i];
					}
					r[k][i]=S/d[k];
				}

				for(int i=k+1;i<m+1;i++)
				{
					for(int j=0;j<11;j++)
					{
						MatrixP[j][i]=MatrixP[j][i]-r[k][i]*q[j][k];
					}
				}                        
		 } 

				for(int i=0;i<m;i++)
				{
					z[i]=r[i][m];  
				}

				x[m-1]=z[m-1];
				for(int k=2;k<=m;k++)
				{
					double SSS=0;
					int nn=0;
					for(int j=m-k+1;j<=m;j++)
						SSS=SSS+r[m-k][j]*x[j];
						
					x[m-k]=z[m-k]-SSS;
				}   


		double ratio=1;
		for(int i=0;i<Integer.parseInt(JLT.getText());i++)
		ratio=ratio-x[i];
		
		ratio=RND(ratio,5);	

		for(int i=0;i<14;i++)
		{
			E[i]=0;
		
				for(int j=0;j<Integer.parseInt(JLT.getText());j++)
				E[i]=E[i]+x[j]*a[i][j];
				

		}

 		for(int k=0;k<Integer.parseInt(JLT.getText());k++)
     		   x[k]=RND(x[k],5); 

		double SSR=0;
		for(int i=0;i<14;i++)
		{
		double D1=RND(MatrixQ[i]-E[i],3);
		DTMR.setValueAt(Double.toString(D1),i,0);
		SSR=SSR+(MatrixQ[i]-E[i])*(MatrixQ[i]-E[i]);
		}

		String S1= new String(JLSP.getText());
int CompNumber=Integer.parseInt(S1);
		double RMSR=Math.sqrt(SSR/CompNumber);
		RMSR=RND(RMSR,6);
		JL6.setText(Double.toString(RMSR));

		SSR=RND(SSR,6);

		for(int i=0;i<7;i++)
		DTMD.setValueAt("",0,i);
		
		DTMD.setValueAt(Double.toString(1),0,0);
		DTMD.setValueAt(Double.toString(ratio),0,6);
		JL4.setText(Double.toString(SSR));

		int nJC=0;
		for(int j=0;j<5;j++)
		{
		  if((DTMSelect.getValueAt(0,j)).equals(Integer.toString(1)))
			{
			DTMD.setValueAt(Double.toString(x[nJC]),0,(j+1));
			nJC=nJC+1;
			}
		}
	}

	public static double RND(double a, int b)
	{
	double n=1;
	for(int i=0;i<b;i++)
	n=n*10;
	a=Math.round(a*n);
	a=(double)(a/n);
	return a;
	}

     public static void main (String args[])
     {
     MassBalanceCalculator f =new MassBalanceCalculator(); 
     f.setBounds(140,120,670,545);
     f.show();
     }
}
